#ifndef __FILE
#define __FILE

#define ODLS "\nODLS phase unwrapping, VERSION 1.0\n"
#define OPEN_FILE_ERROR 10
#define OUT_OF_MEMORY	20
#define WRITE_ERROR		30
#define READ_ERROR		40
#define RUNTIME_ERROR	50
#define CONFIG_ERROR	60
#define TRUE			1
#define FALSE			0
#define ZERO			1.0e-4
#define INF				10
#define PI				3.141593
#define MAXSTRLEN		512
#define MARGIN_OF_ERROR			1.0e-4

#define STDERR		stderr
#define STDOUT		stdout

#define INITSIZE	5000
#define INCRESIZE	1000

#define POS_RES		0x01
#define NEG_RES		0x02
#define ACTIVE		0x04
#define VISITED		0x08
#define AVOID		0x11	//no use
#define RESIDUE		(POS_RES|NEG_RES)
#define CUT			0x80
#define GROUND		0x10

#define NEED_TODO	0x20
#define CANBE_INIT	0x40

#define MAX_KIND_BLOCK	250000
#define MAX_CLUSTER		20000

#define DOUBLE(x)	((x)*(x))
#define MIN(a,b)	((a)<(b)?(a):(b))
#define DIS(x1,y1,x2,y2) ( sqrt( ((x2)-(x1))*((x2)-(x1)) + ((y2)-(y1))*((y2)-(y1)) ) )
#define PIFIX(x)	((x)>PI ? (x) -= 2*PI : ((x) < -PI ? (x) += 2*PI : (x)))
#endif