/*************************************************************************************************************************/
/* Description:
/* This program is used to generate residues for input interferogram.

/* Release date of FLSv1.0: Aug.05, 2018
/* Latest updated date of FLSv2.0: Oct.02, 2018
/*************************************************************************************************************************/

#include <stdio.h>
#include "residue.h"
#include "util.h"
#include "file.h"


int Residues(float *phase, unsigned char *bitflags, int pos_code, int neg_code, int avoid_code, 
			  const int xsize, const int ysize) {

	int i,j,k,resNum = 0;
	float r;

	for (i = 0; i < xsize-1; ++i) {
		fprintf(STDOUT, "\b\b\b\b%-d%%", i*100/(xsize-2));
		for (j = 0; j < ysize-1; ++j) {
			k = i * ysize + j;
			if (bitflags[k] & avoid_code || bitflags[k+1] & avoid_code 
				|| bitflags[k+ysize] & avoid_code || bitflags[k+ysize+1] & avoid_code) {

				continue;
			}
			r = Gradient(phase[k+1], phase[k]) + Gradient(phase[k+ysize+1], phase[k+1]) 
				+ Gradient(phase[k+ysize], phase[k+ysize+1]) + Gradient(phase[k], phase[k+ysize]);
			if (r > 0.001) {
				bitflags[k] |= pos_code;
				++resNum;
			} else if (r < -0.001) {
				bitflags[k] |= neg_code;
				++resNum;
			}
		}
	}
	return resNum;
}