#ifndef __UTIL
#define __UTIL


typedef struct LinkedNode_tag {
	int *elem;
	int dim;
	struct LinkedNode_tag *next;
} LinkedNode;

typedef struct LinkedQueue_tag {
	struct LinkedNode_tag *head;
	struct LinkedNode_tag *tail;
} LinkedQueue;

typedef struct IntNode_tag {
	int data;
	struct IntNode_tag *next;
} IntNode;

typedef struct IntQueue_tag {
	struct IntNode_tag *head;
	struct IntNode_tag *tail;
} IntQueue;

void ErrorHandle(char message[], int exit_code);
void OpenFile(FILE **fp, const char *filepath, const char *mode);
void AllocateMemory(void **array, const int len, const int elemsize);
void ReadData(FILE *fp, void *data, const int len, const int elemsize);
void WriteData(FILE *fp, void *data, const int len, const int elemsize);

void Allocate2DArray(void ***array, const int xsize, const int ysize, const int elemsize);
void Free2DArray(void **array, const int xsize);
void Write2DArray(FILE *fp, void **array, const int xsize, const int ysize, const int elemsize);

float Gradient(float num1, float num2);

int ReadConfigFile(const char conf_file[], char phase_file[], char qual_file[], char out_file[], int *xsize, 
				   float *lowdis, float *highdis, float *delta, int *cluster_limit);

int StrToLong(char *str, long *lnum);
int StrToDouble(char *str, double *dnum);
int GetYsize(FILE *pfp, int xsize, int elemsize);

//void QuickSortResidueList(ResidueNode *ResidueList, int low, int high);
void LinearSortNew(short *row, short *col, int *type, float *dist, const int len);
void Maximum(int *array, int xsize, int ysize, int *output);
int	 BinSearch(int *array, int low, int high, int elem);
void ReKind(int *type, const int len);

//some operation for linkedlist
void InitQueue(LinkedQueue *Q);
void EnQueue(LinkedQueue *Q, int *new_data, int dim);
void DestroyQueue(LinkedQueue *Q);

//some operation for int queue
void InitIntQueue(IntQueue *Q);
void EnIntQueue(IntQueue *Q, int data);
int	 DeIntQueue(IntQueue *Q);
void DestroyIntQueue(IntQueue *Q);
#endif